#ifndef __NRF_PEDO_AND_CAMEAR_SERVER_H__
#define __NRF_PEDO_AND_CAMEAR_SERVER_H__

#if defined(_DISABLE_OBJECT_INTERFACE)
#define PAC_OBJECT_INTERFACE(INTERFACE,FUN) gNrfPac##FUN
#else
#define PAC_OBJECT_INTERFACE(INTERFACE,FUN) INTERFACE->FUN
#endif

#define CAMEAR_TOUCH_MARK_1 0x55
#define CAMEAR_TOUCH_MARK_2 0xAA


typedef struct _NrfPacInterface_t{
    //struct _IapIoInterface{
    void (*IoTimeOutProcess)(void *me);
    IAP_HOST_TYPE (*GetIoType)(void *me);
    IAP_IO_STATE (*GetIoState)(void *me);
    void (*SetIoState)(void *me,IAP_IO_STATE state);
    void (*IapIoSend)(void *me, uint8_t *buf, uint16_t length);
    IAP_RECEIVE_STATE (*GetIapReceiveState)(void *me);
    void (*ClearIapReceiveState)(void *me);
    //}
#if !defined(_DISABLE_OBJECT_INTERFACE)    
    void (*UpdatePedometerDatas)(void *me, uint32_t steps, uint32_t distance, uint32_t calors);
    void (*UpdateCameraState)(void *me, uint8_t openEn);
    void (*SendNotify)(void *me);

    uint8_t (*GetCameraState)(void *me);
    void (*TouchTheCamera)(void *me);
    uint8_t (*ProximityAlateProcess)(void *me);
#endif    
}NrfPacInteface_t;


typedef struct _NrfPacHal_t NrfPacHal_t;
struct _NrfPacHal_t{
    NrfPacInteface_t Interface;
    	
    ble_gap_sec_params_t  mSecParams;  
   
    ble_pac_t             mPac;

#if !defined(_DISABLE_PROXIMITY_SERVICE)
    ble_tps_t             mTps;                                         
    ble_ias_t             mIas;                                           
    ble_lls_t             mLls;    
    ble_ias_c_t           mIasC;   
#endif    
    uint32_t mReceiveTimoutRecord;
        
    uint16_t mPackLength;	
    uint16_t mReceiveLength;    
        
    uint16_t mConnHandle;    

    PEDO_BLE_ADVERTISING_MODE_t mAdvertisingMode;
    
    IAP_RECEIVE_STATE mReceiveState;  
    IAP_IO_STATE mIoState;
    IAP_IO_STATE mIoSpeed;
    
    uint8_t  mDirectAdvCnt;
    int8_t   mLastConnectedMaster; 
    
#if !defined(_DISABLE_CAMERA_SERVICE)    
    uint32_t mSteps;
    uint32_t mDistance;
    uint32_t mCalors;   
    uint8_t  mCameraOpenEnable;
    uint8_t  mCameraTouch;
    uint8_t  mUpdateMark;
    uint8_t  mPedoUpdateCount;
#endif
    bool     mIsLinkLossAlerting;   
    bool     mIsHighAlertSignalled;
  
};

NrfPacInteface_t *GetNrfPacInterface(void *param);

extern NrfPacHal_t     gNrfPacHal;
extern NrfPacInteface_t *gNrfPac;

extern uint8_t gNrfPacProximityAlateProcess(void *me);

extern void gNrfPacUpdatePedometerDatas(void *me, uint32_t steps, uint32_t distance, uint32_t calors);

extern void gNrfPacUpdateCameraState(void *me, uint8_t openEn);
extern void gNrfPacSendNotify(void *me);

extern uint8_t gNrfPacGetCameraState(void *me);
extern void gNrfPacTouchTheCamera(void *me);
extern uint8_t gNrfPacProximityAlateProcess(void *me);

#endif

